//Copyright (C) 2004, Brian Enigma <enigma at netninja.com>
//This file is part of MagicCodes.
//
//MagicCodes is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//
//MagicCodes is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with Foobar; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package org.ninjasoft.magiccodes.plugins;

/**
 * The Texel code from the MU arg.  In this representation, the first byte is
 * plaintext.  It gets XORed with the next byte, etc.
 * 
 * Sample data 1:
 * 741116071d0709470844030e050d07094743110b09041b1c10111b19045446091d52531606160717455406130f1d1e041a001a060147
 * 
 * Sample data 2:
 * 771e070a480c52130807420c42101b0e0f1c5453061b400e4809131644541b4f5316004b0e4302041612135e0c43020f495354440b4f4d18160b484e0118590e4e0b13131752531b071a1908444809171345430c02084b0e571e05004c54060b59541b4f55051c030e054441050010184c4405151541490f4643020f    
 * @author enigma
 */
public class TexelCode implements Plugin {
	public String getName() {
		return "Texel Decode";
	}
	public String getDescription() {
		return "The chaining XOR code Texel used in MU";
	}
	public boolean usesKey() {
		return false;
	}
    public boolean isInformational() {
        return false;
    }
	public int[] doAction(int[] in, int[] key) {
        int previous = 0;
        for (int i=0; i<in.length; i++) {
            int newValue = (in[i] ^ previous) % 256;
            previous = newValue;
            in[i] = newValue;
        }
        return in;
	}
}
